unit uFileDialog;

{$mode objfpc}{$H+}

{
  zum Test von FileNameEdit1, siehe hierzu
  https://www.lazarusforum.de/viewtopic.php?t=12936
  vielleicht hilft das
  https://www.delphibasics.co.uk/RTL.php?Name=TOpenDialog

  https://forum.lazarus.freepascal.org/index.php?topic=20610.0
  https://www.lazarusforum.de/viewtopic.php?t=12936
  zeigt, wie man es verwendet
}

interface

uses
  Classes
  , SysUtils
  , Forms
  , Controls
  , Graphics
  , Dialogs
  , EditBtn
  , StdCtrls
  , ExtCtrls
  , Buttons
  ;

type

  { TFileDialogFrm }

  TFileDialogFrm = class(TForm)
    Label5: TLabel;
    OpenEd         : TEdit;
    saveEd         : TEdit;
    Label1         : TLabel;
    Label2         : TLabel;
    Label3         : TLabel;
    Label4         : TLabel;
    OpenPanel      : TPanel;
    SavePanel      : TPanel;
    OpenSB         : TSpeedButton;
    SaveSB         : TSpeedButton;
    FileNameEdit1  : TFileNameEdit;
    DirectoryEdit1 : TDirectoryEdit;
    procedure FormShow(Sender: TObject);
    procedure BtnsClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
  private

  public

    OD   : TOpenDialog;
    SD   : TSaveDialog;

const
  iniFilter = 'iniFile (*.ini)|*.ini';

  end;

var
  FileDialogFrm: TFileDialogFrm;

implementation

{$R *.lfm}

{ TFileDialogFrm }

procedure TFileDialogFrm.FormShow(Sender: TObject);

begin
  FileNameEdit1.initialDir := ExtractFilePath(FileNameEdit1.FileName);
  FileNameEdit1.Filter     := iniFilter;

{ FileNameEdit ist unter Windows fehlerhaft, siehe

  https://lazarusforum.de/viewtopic.php?f=55&t=15516&sid=17e01d0e8a7c2de3d3bbf90c39902dfc
}

//  zum Testen der alten Versionen setze:
{
  FileNameEdit1.DialogOptions:=FileNameEdit1.DialogOptions
                               + [ofOldStyleDialog];
}
end;


procedure TFileDialogFrm.BtnsClick(Sender: TObject);

begin

  if Sender = SaveSB then begin

    if not assigned (SD)
      then SD := TSaveDialog.Create(self);

    SD.InitialDir := ExtractFilePath(SaveEd.Text);
    SD.Filter     := iniFilter;
    SD.Title      := 'PraxisRg.ini';

    if SD.Execute then
      SaveEd.Text := SD.Filename;

  end;

  if Sender = OpenSB then begin
    if not assigned (OD)
      then OD := TOpenDialog.Create(self);

    OD.InitialDir := ExtractFilePath(OpenEd.Text);
    OD.Filter     := iniFilter;
    OD.Title      := 'PraxisRg.ini';

    if OD.Execute then
      OpenEd.Text := OD.Filename;

  end;

end;

procedure TFileDialogFrm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  sd.Free;
  od.Free;
end;


end.

